<?php
/**
 * @brief		(BIM) Topic Thumbnail Application Class
 * @author		<a href='https://ipsviet.com'>onlyME</a>
 * @copyright	(c) 2019 onlyME
 * @package		Invision Community
 * @subpackage	(BIM) Topic Thumbnail
 * @since		17 Jan 2019
 * @version		
 */
 
namespace IPS\tthumb;

/**
 * (BIM) Topic Thumbnail Application Class
 */
class _Application extends \IPS\Application
{
	/**
	 * Install 'other' items. Left blank here so that application classes can override for app
	 *  specific installation needs. Always run as the last step.
	 *
	 * @return void
	 */
	public function installOther()
	{
		foreach ( \IPS\Plugin::plugins() as $plugin )
		{
			if( mb_strpos( $plugin->name, "Topic Thumbnail" ) !== FALSE )
			{
				$tthumbPlugin = $plugin;
				@unlink( \IPS\Application::getRootPath() . "/plugins/" . $plugin->location . "/uninstall.php" );
				break;
			}
		}

		if ( $tthumbPlugin )
		{
			foreach ( \IPS\Db::i()->select( '*', 'core_sys_conf_settings', "conf_key LIKE 'bim_tthumb_%'" ) as $row )
			{
				$newKey = str_replace( 'bim_', '', $row['conf_key'] );
				\IPS\Settings::i()->changeValues( array( $newKey => $row['conf_value'] ) );
			}
	
			# Disable plugin
			if ( $tthumbPlugin->enabled )
			{
				$tthumbPlugin->enabled = 0;
				$tthumbPlugin->save();
			}
			
			# Check storage of the plugin
			$row = \IPS\Db::i()->select( '*', 'core_sys_conf_settings', array( 'conf_key=?', 'upload_settings' ) )->first();
			$settings = json_decode( $row['conf_value'], TRUE );

			if ( isset( $settings['filestorage__forums_topicThumbnail'] ) )
			{
				$settings['filestorage__tthumb_Images'] = $settings['filestorage__forums_topicThumbnail'];

				\IPS\Settings::i()->changeValues( array( 'upload_settings' => json_encode( $settings ) ) );
			}		
		}
	}	
}