//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class tthumb_hook_forums_Forum extends _HOOK_CLASS_
{
	/*-------------------------------------------------------------------------*/
	// Permissions
	/*-------------------------------------------------------------------------*/		
	public function canChangeThumb($author)
	{
		try
		{
			try
			{
				if ( \IPS\Settings::i()->tthumb_on != 1 )
				{
					return false;
				}
				
				if ( \IPS\Settings::i()->tthumb_authorcanchange == 1 && \IPS\Member::loggedIn()->member_id > 0 && \IPS\Member::loggedIn()->member_id == $author )
				{
					return true;
				}
				
				if ( \IPS\Member::loggedIn()->inGroup( explode(",", \IPS\Settings::i()->tthumb_memgroup_mana) ) )
				{
					return true;
				}
				
				return false;
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	public function canSeeThumb()
	{
		try
		{
			try
			{
				if ( \IPS\Settings::i()->tthumb_on != 1 )
				{
					return false;
				}
				
				if ( \IPS\Request::i()->cookie['tthumb_off'] != 1 && \IPS\Member::loggedIn()->inGroup( explode( ',', \IPS\Settings::i()->tthumb_memgroup_see ) ) )
				{
					if ( $this->club() )
					{
						return \IPS\Settings::i()->tthumb_club == 1 ? true : false;
					}
		
					if ( \IPS\Settings::i()->tthumb_forum == '0' || \in_array( $this->id, explode( ",", \IPS\Settings::i()->tthumb_forum ) ) )
					{
						return true;
					}				
				}
		
				return false;
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	public function useOgImage()
	{
		try
		{
			try
			{
				if ( \IPS\Settings::i()->tthumb_on != 1 || \IPS\Settings::i()->tthumb_og_image != 1 )
				{
					return false;
				}
				
				if ( $this->club() && \IPS\Settings::i()->tthumb_club != 1)
				{
					return false;
				}
				
				if ( \IPS\Settings::i()->tthumb_forum != '0' && !\in_array( $this->id, explode( ",", \IPS\Settings::i()->tthumb_forum ) ) )
				{
					return false;
				}
				
				return true;
				}
				catch ( \Error | \RuntimeException $e )
				{
					if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
					{
						\IPS\Log::log( $e, 'hook_exception' );
					}
	
					if ( method_exists( get_parent_class(), __FUNCTION__ ) )
					{
						return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
					}
					else
					{
						throw $e;
					}
				}
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}

				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
	}	
	
	public function isGalleryMode()
	{
		try
		{
			try
			{
				if ( \IPS\Settings::i()->tthumb_on != 1 )
				{
					return false;
				}
				
				if ( \IPS\Request::i()->cookie['tthumb_off'] != 1 && \IPS\Member::loggedIn()->inGroup( explode( ',', \IPS\Settings::i()->tthumb_memgroup_see ) ) )
				{
					if ( !$this->club() && ( \IPS\Settings::i()->tthumb_gallerymode == '0' || \in_array( $this->id, explode( ",", \IPS\Settings::i()->tthumb_gallerymode ) ) ) )
					{
						return true;
					}
				}
				return false;
				}
				catch ( \Error | \RuntimeException $e )
				{
					if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
					{
						\IPS\Log::log( $e, 'hook_exception' );
					}
	
					if ( method_exists( get_parent_class(), __FUNCTION__ ) )
					{
						return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
					}
					else
					{
						throw $e;
					}
				}
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}

				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
	}	

}
