//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class tthumb_hook_forums_Topic extends _HOOK_CLASS_
{
	public static $noThumb = null;
	
	public static $_thumbs = null;	
	
	public function tthumbGetData()
	{
		try
		{
			try
			{
				if ( self::$_thumbs[ $this->tid ] === NULL )
				{
					try
					{
						self::$_thumbs[ $this->tid ] = \IPS\Db::i()->select( '*', 'tthumb_images', array( 'img_topic_id=?', $this->tid ), NULL, array(0, 1) )->first();
					}
					catch ( \UnderflowException $e ) 
					{
						\IPS\Db::i()->insert( 'tthumb_images', array(
							'img_topic_id'		=> $this->tid,
							'img_image'			=> NULL,
							'img_thumb'			=> NULL,
						) );				
					}			
				}
		
				return self::$_thumbs[ $this->tid ];		
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	/*-------------------------------------------------------------------------*/
	// Show thumbnail
	// Type: 
	// 0: small thumbnail
	// 1: large thumbnail
	/*-------------------------------------------------------------------------*/	
	public function tthumb_show( $type=0 )
	{	
			try
			{
				try
				{
				if ( \IPS\Settings::i()->tthumb_on != 1 )
				{
					return;
				}
				
				# No thumb url
				if ( !self::$noThumb )
				{
					self::$noThumb = \IPS\Settings::i()->tthumb_defaultimg ? (string) \IPS\File::get( 'core_Theme', \IPS\Settings::i()->tthumb_defaultimg )->url : (string) \IPS\Theme::i()->resource( 'noThumb.png', 'tthumb', 'front' );
				}
				
				$thumb = self::$noThumb;
		
				# Get thumb
				$data = $this->tthumbGetData();
		
				if ( $data['img_thumb'] == 'no' )
				{
					return $thumb;
				}
				
				if ( $type == 1 )
				{
					if ( $data['img_image'] == NULL ) // if no large thumbnail, use the first image in post
					{
						$iArr = $this->tthumb_getIMGsInPost();
						if (\count($iArr) > 0)
						{
							return $iArr[0];
						}
					}
					else
					{
						try
						{
							$f = \IPS\File::get( 'tthumb_Images', $data['img_image'] );
							if ($f->filesize() > 0)
							{
								return (string) $f->url;
							}
						}
						catch( \OutOfRangeException $e ){}
					}
				}
				
				if ( $data['img_thumb'] )
				{
					if ( \mb_stripos( $data['img_thumb'], 'fileStore.core' ) === false AND \mb_stripos( $data['img_thumb'], '___base_url___' ) === false )
					{
						try
						{
							return (string) \IPS\File::get( 'tthumb_Images', $data['img_thumb'] )->url;
						}
						catch( \OutOfRangeException $e )
						{
							return $thumb;
						}					
					}
					else
					{
						return $this->tthumbGetRealIMG( $data['img_thumb'] );
					}			
				}
				else
				{
					$imgsInPost = $this->tthumb_getIMGsInPost();
		
					if ( \count( $imgsInPost ) > 0 )
					{
						$thumb = $this->tthumb_getIMGsInPost()[0];
						\IPS\Db::i()->update( 'tthumb_images', array( 'img_thumb' => $thumb ), array( 'img_topic_id=?', $this->tid ) );
						return $thumb;
					}
					else
					{
						\IPS\Db::i()->update( 'tthumb_images', array( 'img_thumb' => 'no' ), array( 'img_topic_id=?', $this->tid ) );
					}
				}
		
				return $thumb;
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	public function tthumbGetRealIMG( $txt )
	{
		try
		{
			try
			{
				if ( mb_strpos( $txt, 'fileStore.core_Attachment' ) !== false )
				{
					$isAtt = true;
				}
				$txt = str_replace("fileStore.core_Emoticons", "", $txt);
				$txt = str_replace("fileStore.core_Attachment", "", $txt);
				$txt = str_replace("<>", "", $txt);			
				$txt = str_replace("%3C%3E", "", $txt);
				$txt = str_replace( '<___base_url___>', rtrim( \IPS\Settings::i()->base_url, '/' ), $txt );
				
				if ( $isAtt ) 
				{
					$txt = (string) \IPS\File::get( 'core_Attachment', $txt )->url;
				}
		
		// Fix double slashes	
				$parts = explode('//', $txt, 2);
				$parts[1] = rtrim(preg_replace('@/+@', '/', $parts[1]), '/');
				$txt = implode('//', $parts);
				unset($parts);
		
		// Remove double slashes at the end
				if (mb_strpos($txt, "fileStore.") !== false || mb_strpos($txt, "___base_url___") !== false)
				{
					$txt = rtrim($txt,"/");
				}		
				
		// Done
				return $txt;
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	protected function imageExtension($contentType) 
	{
		try
		{
			try
			{
				switch ($contentType) 
				{
					case 'image/jpeg':
					case 'image/jpg':
						return '.jpg';
					case 'image/png':
						return '.png';
					case 'image/gif':
						return '.gif';
					case 'image/bmp':
						return '.bmp';
					case 'image/webp':
						return '.webp';
					default:
						return null;
				}
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	/*-------------------------------------------------------------------------*/
	// Get all images in first post of topic
	/*-------------------------------------------------------------------------*/	
	public function tthumb_getIMGsInPost( $content=null )
	{
		try
		{
			try
			{
				$thumbs = array();
		
				if ( !$content )
				{
					if ( \IPS\Settings::i()->tthumb_get_full )
					{
						try
						{
							$where[] = array( "topic_id=?", $this->tid );
							$where[] = array( "(post LIKE CONCAT( '%', ?, '%' ) OR post LIKE CONCAT( '%', ?, '%' ))", 'ipsEmbeddedVideo', '<img ' );
							$row = \IPS\Db::i()->select( '*', 'forums_posts', $where, 'pid ASC', 1 )->first();
							$pid = $row['pid'];
						}
						catch ( \UnderflowException $e ) {}				
					}
					else
					{
						$pid = $this->topic_firstpost;
					}
					
					try 
					{
						$txt = \IPS\forums\Topic\Post::load( $pid )->post;
					}
					catch ( \OutOfRangeException $e ){}	
				}
				else
				{
					$txt = $content;
				}
				
				if ( !$txt )
				{
					return $thumbs;
				}
				
				try
				{
					$source = new \IPS\Xml\DOMDocument( '1.0', 'UTF-8' );
					$source->loadHTML( \IPS\Xml\DOMDocument::wrapHtml( $txt ) );
					$contentImages = $source->getElementsByTagName( 'img' );
					foreach( $contentImages as $el )
					{
						if ( \IPS\Settings::i()->lazy_load_enabled )
						{
							$datasrc = $this->tthumbValidURL( $el->hasAttribute('data-src') ? $el->getAttribute( 'data-src' ) : $el->getAttribute( 'src' ) );
		
							if ( mb_strpos( $datasrc, 'fileStore.core_Emoticons' ) === false )
							{
								$thumbs[] = $this->tthumbGetRealIMG( $datasrc );
							}					
						}
						else
						{
							if ( $el->hasAttribute('src') )
							{
								$src = $this->tthumbValidURL( $el->getAttribute( 'src' ) );
								if ( mb_strpos( $src, 'fileStore.core_Emoticons' ) === false )
								{
									$thumbs[] = $this->tthumbGetRealIMG( $src );
								}
							}
						}
					}
					
					$contentIframes = $source->getElementsByTagName( 'iframe' );
					
					foreach( $contentIframes as $el )
					{
						if ( \IPS\Settings::i()->lazy_load_enabled )
						{
							$thumbs[] = $this->tthumb_videoThumb( $el->hasAttribute('data-embed-src') ? $el->getAttribute( 'data-embed-src' ) : $el->getAttribute( 'src' ) );					
						}
						else
						{
							if ( \mb_strpos( $el->getAttribute( 'src' ), 'core/interface/index.html') !== FALSE )
							{
								$iframeSrc = $el->getAttribute( 'data-embed-src' );
							}
							else
							{
								$iframeSrc = $el->getAttribute( 'src' );
							}
							$thumbs[] = $this->tthumb_videoThumb( $iframeSrc );
						}
					}
		
					preg_match_all( '/\[photo=(.+?)\](.+?)\[\/photo\]/i', $txt, $match );
					for ( $i = 0 ; $i < \count($match[0]) ; $i++ )
					{
						$thumbs[] = $this->tthumbGetRealIMG( strip_tags($match[1][$i]) );
					}
					
					preg_match_all( '/\[photo=(.+?)\]\[\/photo\]/i', $txt, $match );
					for ( $i1 = 0 ; $i1 < \count($match[0]) ; $i1++ )
					{
						$thumbs[] = $this->tthumbGetRealIMG( strip_tags($match[1][$i1]) );
					}
					
					preg_match_all( '/\[img\](.+?)\[\/img\]/i', $txt, $match );
					for ( $i2 = 0 ; $i2 < \count($match[0]) ; $i2++ )
					{
						$thumbs[] = $this->tthumbGetRealIMG( strip_tags($match[1][$i2]) );
					}			
				}
				catch ( \Exception $e ) {}	
				
				if ( \IPS\Settings::i()->tthumb_second_img == 1 )
				{
					if ( $thumbs && \count( $thumbs ) > 1 )
					{
						unset( $thumbs[0] );
						$thumbs = array_values( $thumbs );				
					}
				}
				
				if ($thumbs && \count($thumbs) > 0)
				{
					$thumbs = array_filter( $thumbs );
				}
		
				return $thumbs;
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	/*-------------------------------------------------------------------------*/
	// Show video thumbnail ( support youtube & vimeo )
	/*-------------------------------------------------------------------------*/	
	protected function tthumb_videoThumb( $txt )
	{
		try
		{
			try
			{
				if ( preg_match('%(?:youtube(?:-nocookie)?\.com/(?:[^/]+/.+/|(?:v|e(?:mbed)?)/|.*[?&]v=)|youtu\.be/)([^"&?/ ]{11})%i', $txt, $match) )
				{
					$thumb = "https://img.youtube.com/vi/{$match[1]}/hqdefault.jpg";
				}
				elseif ( preg_match('/https?:\/\/(.+)?(wistia.com|wi.st|net)\/(medias|embed)\/(.*)\/(.*)/', $txt, $match ) )
				{
					try
					{
						$wID = $match[5];
						$url = "https://fast.wistia.com/oembed?url=http://home.wistia.com/medias/" . $wID;				
						$wData = \IPS\Http\Url::external( $url )->request()->get()->decodeJson();
						$img = explode("?", $wData['thumbnail_url']);
						$width = ( \IPS\Settings::i()->tthumb_gallerymode != '0' && !\in_array($this->container()->id, explode(",", \IPS\Settings::i()->tthumb_gallerymode)) ) ? \IPS\Settings::i()->tthumb_width : 400;
						$height = ( \IPS\Settings::i()->tthumb_gallerymode != '0' && !\in_array($this->container()->id, explode(",", \IPS\Settings::i()->tthumb_gallerymode)) ) ? \IPS\Settings::i()->tthumb_height : 340;
						$thumb = $img[0] . "?image_crop_resized=" . $width . "x" . $height;
					}
					catch ( \Exception $e ){}
				}
				elseif ( preg_match( "/dailymotion.com\/(.*?)/", $txt, $match ) )
				{
					$id = strtok(basename($txt), '_');
					try
					{
						$request = \IPS\Http\Url::external( "https://api.dailymotion.com/video/" . $id . "?fields=thumbnail_480_url" )->request()->get();
						$output = json_decode($request);
						return $output->thumbnail_480_url;
					}
					catch ( \Exception $e ) {}	
				}
				elseif ( preg_match( "/vimeo.com\/([1-9.-_]+)/", $txt, $match ) || preg_match( "/vimeo.com\/video\/([1-9.-_]+)/", $txt, $match ) )
				{
					$vurls = explode( "/", $txt );
					$vmid = $vurls[ \count( $vurls ) - 1 ];
					try
					{
						$request = \IPS\Http\Url::external( "https://vimeo.com/api/oembed.json?url=https://player.vimeo.com/video/" . $vmid )->request()->get();
						$output = json_decode( $request );
						return $output->thumbnail_url;					
					}
					catch ( \Exception $e ) {}
				}		
				return $thumb;
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	/*-------------------------------------------------------------------------*/
	// Hook to posting form
	/*-------------------------------------------------------------------------*/		
	public static function formElements( $item=NULL, \IPS\Node\Model $container=NULL )
	{
		try
		{
			try
			{
				$formElements = parent::formElements( $item, $container );
				
				if ( \IPS\Request::i()->do != 'multimodComment' && $container && $container->canChangeThumb( \IPS\Member::loggedIn()->member_id ) && ( $container->canSeeThumb() || $container->isGalleryMode() ) )
				{
					if ( $item != null )
					{
						$data = $item->tthumbGetData();
					}
					
					if ( \IPS\Settings::i()->tthumb_postURL )
					{
						if ( ! \IPS\Settings::i()->tthumb_forcethumb )
						{
							$options['tthumbnail'] = 'tthumb_select';
						}
						
						$options['fromURL'] = 'tthumb_fromURL';		
					}
					else
					{
						if ( $item && $data['img_thumb'] )
						{
							$options['tthumbnail'] = 'tthumb_select';
						}
					}
					
					$options['upload'] = 'tthumb_upload';
					
					if ( $item && ! \IPS\Settings::i()->tthumb_forcethumb )
					{
						$options['remove'] = 'tthumb_remove';
					}
					
					$toggles = array( 'upload' => array( 'tthumb_upload' ), 'fromURL' => array( 'tthumb_fromURL' ) );
		
					$bim['tthumb_type'] = new \IPS\Helpers\Form\Select( 'tthumb_type', ( $item && $data['img_image'] ) ? 'upload' : 'tthumbnail', \IPS\Settings::i()->tthumb_forcethumb, array( 'options' => $options, 'toggles' => $toggles ) );
					
					if ( \IPS\Settings::i()->tthumb_postURL )
					{
						$bim['tthumb_fromURL'] = new \IPS\Helpers\Form\Text( 'tthumb_fromURL', ( $item && $data['img_thumb'] != 'no' ) ? $data['img_thumb'] : NULL, \IPS\Settings::i()->tthumb_forcethumb, array(), NULL, NULL, NULL, 'tthumb_fromURL' );
					}
		
					$bim['tthumb_upload'] = new \IPS\Helpers\Form\Upload( 'tthumb_upload', $data['img_image'] ? \IPS\File::get( 'tthumb_Images', $data['img_image'] ) : NULL, \IPS\Settings::i()->tthumb_forcethumb, array( 
						'image' 			=> array( 'maxWidth' => 600, 'maxHeight' => 600 ), 
						'storageExtension' 	=> 'tthumb_Images', 
						'maxFileSize' 		=> \IPS\Settings::i()->tthumb_max_upload > 0 ? \IPS\Settings::i()->tthumb_max_upload : 2, 
						'template' 			=> 'forums.upload.topicthumbnail' 
					), NULL, NULL, NULL, 'tthumb_upload' );
		
					$return = \array_slice($formElements, 0, 1, true) + $bim + \array_slice($formElements, 1, \count($formElements) - 1, true) ;
					
					return $return;
				}
				
				return $formElements;
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	protected function processAfterCreateOrEdit( $values )
	{
		try
		{
			try
			{
				parent::processAfterCreateOrEdit( $values );
				
				if ( $this->container()->canChangeThumb( \IPS\Member::loggedIn()->member_id ) && ( $this->container()->canSeeThumb() || $this->container()->isGalleryMode() ) )
				{
					$imgArr = array();
					
					if ( $values['tthumb_type'] == 'upload' )	// upload
					{
						$this->createThumbnailFromUploadedImage( $values['tthumb_upload'] );
					}
					elseif ( $values['tthumb_type'] == 'fromURL' )	// external
					{
						$this->createThumbnailFromExternalUrl( (string) $values['tthumb_fromURL'] );
					}
					elseif ( $values['tthumb_type'] == 'tthumbnail' )	// auto
					{
						$data = $this->tthumbGetData();
		
						if ( $data['img_thumb'] )
						{
							return;
						}
		
						$imgArr = $this->tthumb_getIMGsInPost( $values['topic_content'] );
						
						if ( $imgArr[0] )
						{
							$this->createThumbnailFromExternalUrl( $imgArr[0] );
						}					
					}
					else	// xóa
					{
						$this->tthumbDelete();
		
						\IPS\Db::i()->update( 'tthumb_images', array(
							'img_image' => null,
							'img_thumb' => 'no' 
						), array( 'img_topic_id=?', $this->tid ) );				
					}
				}
				else // ko có quyền đổi thumb thì luôn lấy hình ảnh đầu tiên
				{
					$imgArr = $this->tthumb_getIMGsInPost( $values['topic_content'] );
					if ( $imgArr[0] )
					{
						$this->createThumbnailFromExternalUrl( $imgArr[0] );
					}				
				}
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	/*-------------------------------------------------------------------------*/
	// Delete all thumbs from a topic
	/*-------------------------------------------------------------------------*/	
	public function tthumbDelete()
	{
		try
		{
			try
			{
				# Get data
				$data = $this->tthumbGetData();
		
		// Delete files
				if ( ! \in_array( $this->tthumbGetRealIMG( $data['img_thumb'] ), $this->tthumb_getIMGsInPost() ) && $data['img_thumb'] )
				{
					try
					{
						\IPS\File::get( 'tthumb_Images', $data['img_thumb'] )->delete();
					}
					catch( \Exception $e ){}	
				}
		
				if ( ! \in_array( $this->tthumbGetRealIMG( $data['img_image'] ), $this->tthumb_getIMGsInPost() ) && $data['img_image'] )
				{
					try
					{
						\IPS\File::get( 'tthumb_Images', $data['img_image'] )->delete();					
					}
					catch( \Exception $e ){}				
				}	
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	/*-------------------------------------------------------------------------*/
	// Create thumbnail from external url
	/*-------------------------------------------------------------------------*/	
	public function createThumbnailFromExternalUrl( $url )
	{
		try
		{
			try
			{
				if ( !$url )
				{
					return;
				}
		
				$url = $this->tthumbGetRealIMG( $url );
				$url = $this->tthumbValidURL( $url );
				
		// Do not upload thumbnails from 3rd services
				if ( ! \IPS\Settings::i()->tthumb_import_from_3rd )
				{
					$parseUrl = parse_url( $url );
					$host = str_replace( 'www.', '', trim( $parseUrl['host'] ? $parseUrl['host'] : array_shift( explode('/', $parseUrl['path'], 2) ) ) ); 
					
					if ( \in_array( $host, array( 'i.ytimg.com', 'img.youtube.com', 'i.vimeocdn.com', 's1.dmcdn.net', 'static-cdn.jtvnw.net' ) ) 
						|| mb_stripos( $host, "giphy.com" ) !== false 
					)
					{
						$this->tthumbDelete();
						
						\IPS\Db::i()->update( 'tthumb_images', array(
							'img_image' => NULL,
							'img_thumb' => $url
						), array( 'img_topic_id=?', $this->tid ) );	
						
						return;
					}
				}
				
		// Create img
				try
				{
					$response = \IPS\Http\Url::external( $url )->request()->setHeaders( array( 
						'Referer' => \IPS\Settings::i()->base_url
					) )->get();
					
					$maxSize = \IPS\Settings::i()->tthumb_max_upload > 0 ? \IPS\Settings::i()->tthumb_max_upload : 2;
					$contentLength = ( isset( $response->httpHeaders['Content-Length'] ) ) ? $response->httpHeaders['Content-Length'] : ( ( isset( $response->httpHeaders['content-length'] ) ) ? $response->httpHeaders['content-length'] : 0 );
		
					if ((int)$contentLength > $maxSize * 1024 * 1024 )
					{
						return;
					}
		
					$match = FALSE;
					$contentType = ( isset( $response->httpHeaders['Content-Type'] ) ) ? $response->httpHeaders['Content-Type'] : ( ( isset( $response->httpHeaders['content-type'] ) ) ? $response->httpHeaders['content-type'] : NULL );
					if ( $contentType )
					{
						foreach ( \IPS\Image::$imageMimes as $mime )
						{
							if ( $contentType != "image/gif" && preg_match( '/^' . str_replace( '~~', '.+', preg_quote( str_replace( '*', '~~', $mime ), '/' ) ) . '$/i', $contentType ) )
							{
								$match = TRUE;
								break;
							}
						}
					}
					
					if ( !$match )
					{
						return;
					}
		
					try
					{		
						$newImg = \IPS\Image::create( $response );
						$image = \IPS\File::create( 'tthumb_Images', "topic_" . $this->tid . "." . $this->imageExtension( $contentType ), (string) $newImg );
		
						$thumb = $this->cropTThumb( $image, \IPS\Settings::i()->tthumb_width * 3, \IPS\Settings::i()->tthumb_height * 3 );
					
						if ( ! \IPS\Settings::i()->tthumb_download_image )
						{
							$image->delete();
							$image = NULL;
						}
					}
					catch ( \Exception $e ) 
					{
						return;
					}
				}
				catch ( \IPS\Http\Request\Exception $e )
				{
					return;
				}	
		
		// Delete old thumbs
				$this->tthumbDelete();
		
		// Save
				\IPS\Db::i()->update( 'tthumb_images', array(
					'img_image' => $image ? (string) $image : NULL,
					'img_thumb' => (string) $thumb 
				), array( 'img_topic_id=?', $this->tid ) );				
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	  
	/*-------------------------------------------------------------------------*/
	// Create thumbnail from uploaded image
	/*-------------------------------------------------------------------------*/	
	public function createThumbnailFromUploadedImage( $url )
	{
		try
		{
			try
			{
				if ( !$url )
				{
					return NULL;
				}
				if ( \is_object( $url ) )
				{
					$image = $url;
				}
				else 
				{
					try
					{					
						$image = \IPS\File::get( 'tthumb_Images', $url );
					}
					catch( \Exception $e ){}
				}
				
				if ( !$image )
				{
					return;
				}
				
				$maxSize = \IPS\Settings::i()->tthumb_max_upload > 0 ? \IPS\Settings::i()->tthumb_max_upload : 2;
				if ( !$image->isImage() || $image->filesize() > $maxSize * 1024 * 1024  )
				{
					$image->delete();
					return;
				}		
		
				$thumb = $this->cropTThumb( $image, \IPS\Settings::i()->tthumb_width * 3, \IPS\Settings::i()->tthumb_height * 3 );
				
		// Delete old thumbs
				$this->tthumbDelete();
				
		// Save
				\IPS\Db::i()->update( 'tthumb_images', array(
					'img_image' => (string) $image,
					'img_thumb' => (string) $thumb 
				), array( 'img_topic_id=?', $this->tid ) );	
				
				\IPS\Db::i()->delete( 'core_files_temp', array( 'contents=?', (string) $image ) );  // xóa dữ liệu tạm để ko mất file
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}


	/*-------------------------------------------------------------------------*/
	// valid URL
	/*-------------------------------------------------------------------------*/
	public function tthumbValidURL( $url )
	{
		try
		{
			try
			{
				if ( !preg_match("~^(?:f|ht)tps?:~i", $url) && \mb_strpos( $url, "___base_url___" ) === FALSE && \mb_strpos( $url, "fileStore.core_Attachment" ) === FALSE )
				{
					if ( mb_strpos( $url, "//" ) === 0 )
					{
						$url = ( mb_substr( \IPS\Settings::i()->base_url, 0, 5 ) === 'https' ) ? 'https:' . $url : 'http:' . $url;
					}
					else
					{
						$url = rtrim( \IPS\Settings::i()->base_url, '/' ) . '/' . ltrim( $url, '/' );
					}
				}
				return $url;
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	/*-------------------------------------------------------------------------*/
	// Crop thumbnail
	/*-------------------------------------------------------------------------*/
	public function delete()
	{
		try
		{
			try
			{
				# Get data
				$data = $this->tthumbGetData();
		
		// Delete thumbs
				if ( $data['img_thumb'] )
				{
					try
					{
						\IPS\File::get( 'tthumb_Images', $data['img_thumb'] )->delete();
					}
					catch( \Exception $e ){}
				}
				if ( $data['img_image'] )
				{
					try
					{
						\IPS\File::get( 'tthumb_Images', $data['img_image'] )->delete();					
					}
					catch( \Exception $e ){}				
				}
				
				\IPS\Db::i()->delete( 'tthumb_images', array( 'img_topic_id=?', $this->tid ) );
				
				parent::delete();
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	/*-------------------------------------------------------------------------*/
	// truncate
	/*-------------------------------------------------------------------------*/
	public function truncateTitle()
	{	
			try
			{
				try
				{
				$text = $this->title;
				if ( \IPS\Settings::i()->tthumb_grid_truncate_title > 0 )
				{
					$text = $text." ";
					$text = mb_substr($text, 0, \IPS\Settings::i()->tthumb_grid_truncate_title);
					$text = mb_substr($text, 0, mb_strrpos($text,' '));
					$text = $text."...";
				}
				return $text;
				}
				catch ( \Error | \RuntimeException $e )
				{
					if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
					{
						\IPS\Log::log( $e, 'hook_exception' );
					}
	
					if ( method_exists( get_parent_class(), __FUNCTION__ ) )
					{
						return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
					}
					else
					{
						throw $e;
					}
				}
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}

				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
	}	
	
	/*-------------------------------------------------------------------------*/
	// Crop thumbnail
	/*-------------------------------------------------------------------------*/		
	protected function cropTThumb( $file, $maxWidth=NULL, $maxHeight=NULL, $cropToSquare=FALSE )
	{
		try
		{
			try
			{
				try
				{		
					/* Work out size */	
					$defaultSize = explode( 'x', \IPS\THUMBNAIL_SIZE );
					$maxWidth    = $maxWidth ?: $defaultSize[0];
					$maxHeight   = $maxHeight ?: $defaultSize[1];
		
					/* Create an \IPS\Image object */
					$image = \IPS\Image::create( $file->contents() );
		
					/* Crop it */
					if ( $cropToSquare and $image->width != $image->height )
					{
						$cropProperty = ( $image->width > $image->height ) ? 'height' : 'width';
						$image->crop( $image->$cropProperty, $image->$cropProperty );
					}
					
					/* Resize it */
					$image->resizeToMax( $maxWidth, $maxHeight );
		
					/* What are we calling this? */		
					$thumbnailName = "topic_" . $this->tid . ".thumb." . mb_substr(mb_strrchr($file->originalFilename,'.'),1);
		
					/* Create and return */
					return \IPS\File::create( 'tthumb_Images', $thumbnailName, $image, $file->container, FALSE, NULL, TRUE );
				}
				catch ( \Exception  $e ) {}
				}
				catch ( \Error | \RuntimeException $e )
				{
					if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
					{
						\IPS\Log::log( $e, 'hook_exception' );
					}
	
					if ( method_exists( get_parent_class(), __FUNCTION__ ) )
					{
						return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
					}
					else
					{
						throw $e;
					}
				}
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}

				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
	}	
	
	/**
	 * Get snippet HTML for search result display
	 *
	 * @param	array		$indexData		Data from the search index
	 * @param	array		$authorData		Basic data about the author. Only includes columns returned by \IPS\Member::columnsForPhoto()
	 * @param	array		$itemData		Basic data about the item. Only includes columns returned by item::basicDataColumns()
	 * @param	array|NULL	$containerData	Basic data about the container. Only includes columns returned by container::basicDataColumns()
	 * @param	array		$reputationData	Array of people who have given reputation and the reputation they gave
	 * @param	int|NULL	$reviewRating	If this is a review, the rating
	 * @param	string		$view			'expanded' or 'condensed'
	 * @return	callable
	 */
	public static function searchResultSnippet( array $indexData, array $authorData, array $itemData, array $containerData = NULL, array $reputationData, $reviewRating, $view )
	{		
				try
				{
					try
					{
				return $view == 'expanded' ? \IPS\Theme::i()->getTemplate( 'view', 'tthumb', 'front' )->tthumb_searchResult( $indexData ) : '';
				}
				catch ( \Error | \RuntimeException $e )
				{
					if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
					{
						\IPS\Log::log( $e, 'hook_exception' );
					}
	
					if ( method_exists( get_parent_class(), __FUNCTION__ ) )
					{
						return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
					}
					else
					{
						throw $e;
					}
				}
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}

				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
	}	
	
	/**
	 * Process the comment form
	 *
	 * @param	array	$values		Array of $form values
	 * @return  \IPS\Content\Comment
	 */
	public function processCommentForm( $values )
	{
		try
		{
			try
			{
				$comment = parent::processCommentForm( $values );
				
				if ( \IPS\Settings::i()->tthumb_get_full )
				{
					$data = $this->tthumbGetData();
		
					if ( $data['img_thumb'] == 'no' )
					{
						$imgs = $this->tthumb_getIMGsInPost();
		
						if ( $imgs && \count($imgs) > 0 )
						{
							$this->createThumbnailFromExternalUrl( $imgs[0] );
						}
					}
				}
				
				return $comment;
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}
