//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class tthumb_hook_forums_admin_settings extends _HOOK_CLASS_
{

	public function manage()
	{
		try
		{
			try
			{
				\IPS\Output::i()->sidebar['actions']['tthumb'] = array(
					'icon'	=> 'image',
					'link'	=> \IPS\Http\Url::internal( 'app=forums&module=forums&controller=settings&do=tthumbSettings' ),
					'title'	=> 'tthumb_settings',
				);	
					
				parent::manage();
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	public function tthumbSettings()
	{
		try
		{
			try
			{
		// Update database
				if( \IPS\Db::i()->checkForColumn( 'forums_topics', 'upload_thumbnail' ) && \IPS\Db::i()->checkForColumn( 'forums_topics', 'topic_thumbnail' ) )
				{
					\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=forums&module=forums&controller=settings&do=updateForIPS45' ), 'completed' );
				}	
		
				# Form
				$st = \IPS\Settings::i();
				$form = new \IPS\Helpers\Form;	
				
				# General
				$form->addTab( 'tthumb_header_general' );
				
				$form->add( new \IPS\Helpers\Form\YesNo( 'tthumb_on', $st->tthumb_on, FALSE ) );
				
				$form->add( new \IPS\Helpers\Form\YesNo( 'tthumb_og_image', $st->tthumb_og_image ) );
				
				$form->add( new \IPS\Helpers\Form\Number( 'tthumb_max_upload', $st->tthumb_max_upload, FALSE, array( 'decimals' => true, 'max' => 5 ) ) );
				
				$form->add( new \IPS\Helpers\Form\YesNo( 'tthumb_get_full', $st->tthumb_get_full ) );
				
				$form->add( new \IPS\Helpers\Form\YesNo( 'tthumb_download_image', $st->tthumb_download_image ) );
				
				$form->add( new \IPS\Helpers\Form\YesNo( 'tthumb_import_from_3rd', $st->tthumb_import_from_3rd ) );
		
				$form->add( new \IPS\Helpers\Form\YesNo( 'tthumb_postURL', $st->tthumb_postURL ) );
		
				$form->add( new \IPS\Helpers\Form\Upload( 'tthumb_defaultimg', $st->tthumb_defaultimg ? \IPS\File::get( 'core_Theme', $st->tthumb_defaultimg ) : NULL, FALSE, array( 'image' => true, 'storageExtension' => 'core_Theme' ) ) );
			
				$form->add( new \IPS\Helpers\Form\Custom( 'tthumb_rebuild', NULL, FALSE, array( 'getHtml' => function( $element )
				{
					$desc = \IPS\Member::loggedIn()->language()->addToStack('tthumb_rebuild_desc');
					$json = '{"yes":"' . \IPS\Member::loggedIn()->language()->addToStack('tthumb_btn_delete') . '","no":"' . \IPS\Member::loggedIn()->language()->addToStack('tthumb_btn_rebuild') . '","cancel":"Cancel"}';
					
					return \IPS\Member::loggedIn()->language()->addToStack('tthumb_rebuild_link', FALSE, array( 'sprintf' => array( $desc, $json ) ) );
				} ) ) );	
				
				# Standard thumbs
				$form->addTab( 'tthumb_header_standard' );
		
				if ( $st->tthumb_forum == "0" )
				{
					$node_tthumb_forum = 0;
				}
				else if ( $st->tthumb_forum == "" )
				{
					$node_tthumb_forum = null;
				}
				else
				{
					$node_tthumb_forum = $st->tthumb_forum;
				}
		
				$form->add( new \IPS\Helpers\Form\Node( 'tthumb_forum', $node_tthumb_forum, FALSE, array( 
					'class' 		=> 'IPS\forums\Forum', 
					'multiple' 		=> TRUE, 
					'zeroVal' 		=> 'all' 
				) ) );
						
				$form->add( new \IPS\Helpers\Form\YesNo( 'tthumb_club', $st->tthumb_club ) );
						
				$form->add( new \IPS\Helpers\Form\Number( 'tthumb_width', $st->tthumb_width ) );
		
				$form->add( new \IPS\Helpers\Form\Number( 'tthumb_height', $st->tthumb_height ) );
		
				$form->add( new \IPS\Helpers\Form\YesNo( 'tthumb_onhover', $st->tthumb_onhover ) );
		
				$form->add( new \IPS\Helpers\Form\YesNo( 'tthumb_insearch', $st->tthumb_insearch ) );
				
				$form->add( new \IPS\Helpers\Form\YesNo( 'tthumb_instreams', $st->tthumb_instreams ) );
				
				$form->add( new \IPS\Helpers\Form\YesNo( 'tthumb_opacity', $st->tthumb_opacity ) );
				
				# Gallery
				$form->addTab( 'tthumb_header_gallery' );
				if ( $st->tthumb_gallerymode == "0" )
				{
					$node_tthumb_gallerymode = 0;
				}
				else if ( $st->tthumb_gallerymode == "" )
				{
					$node_tthumb_gallerymode = null;
				}
				else
				{
					$node_tthumb_gallerymode = $st->tthumb_gallerymode;
				}	
				$form->add( new \IPS\Helpers\Form\Node( 'tthumb_gallerymode', $node_tthumb_gallerymode, FALSE, array( 
					'class' 		=> 'IPS\forums\Forum', 
					'multiple' 		=> TRUE, 
					'zeroVal' 		=> 'all' 
				) ) );
		
				$form->add( new \IPS\Helpers\Form\Select( 'tthumb_gallerymode_layout', $st->tthumb_gallerymode_layout ? $st->tthumb_gallerymode_layout : "_1", FALSE, array( 'options' => array( '_0' => 'tthumb_masonry', '_1' => 'tthumb_gridview' ) ) ) );
				
				$form->add( new \IPS\Helpers\Form\Number( 'tthumb_gallerymode_itemsperpage', $st->tthumb_gallerymode_itemsperpage ) );
				
				$form->add( new \IPS\Helpers\Form\Number( 'tthumb_grid_truncate_title', $st->tthumb_grid_truncate_title ) );
		
				$form->add( new \IPS\Helpers\Form\Select( 'tthumb_gallerymode_info', $st->tthumb_gallerymode_info, FALSE, array( 'options' => array( 'none' => 'tthumb_info_none', 'author' => 'tthumb_info_author', 'poster' => 'tthumb_info_poster' ) ) ) );
				
				# Forum Icon
				$form->addTab( 'tthumb_header_forumIcon' );
				if ( $st->tthumb_forumIcon == "0" )
				{
					$node_tthumb_forumIcon = 0;
				}
				else if ( $st->tthumb_forumIcon == "" )
				{
					$node_tthumb_forumIcon = null;
				}
				else
				{
					$node_tthumb_forumIcon = $st->tthumb_forumIcon;
				}	
		
				$form->add( new \IPS\Helpers\Form\Node( 'tthumb_forumIcon', $node_tthumb_forumIcon, FALSE, array( 'class' => 'IPS\forums\Forum', 'multiple' => TRUE, 'zeroVal' => 'all' ) ) );
		
				$form->add( new \IPS\Helpers\Form\Number( 'tthumb_forumIcon_width', $st->tthumb_forumIcon_width ) );
		
				$form->add( new \IPS\Helpers\Form\Number( 'tthumb_forumIcon_height', $st->tthumb_forumIcon_height ) );
		
				# Perms
				$form->addTab( 'tthumb_header_permission' );
		
				$form->add( new \IPS\Helpers\Form\Select( 'tthumb_memgroup_see', array_filter( explode( ',', $st->tthumb_memgroup_see ) ), FALSE, array( 'options' => \IPS\Member\Group::groups(), 'parse' => 'normal', 'multiple' => TRUE ) ) );
		
				$form->add( new \IPS\Helpers\Form\Select( 'tthumb_memgroup_mana', array_filter( explode( ',', $st->tthumb_memgroup_mana ) ), FALSE, array( 'options' => \IPS\Member\Group::groups(), 'parse' => 'normal', 'multiple' => TRUE ) ) );
		
				$form->add( new \IPS\Helpers\Form\YesNo( 'tthumb_authorcanchange', $st->tthumb_authorcanchange ) );
				
				$form->add( new \IPS\Helpers\Form\YesNo( 'tthumb_canToggle', $st->tthumb_canToggle ) );
				
				$form->add( new \IPS\Helpers\Form\YesNo( 'tthumb_forcethumb', $st->tthumb_forcethumb ) );
		
				# Save
				if ( $values = $form->values() )
				{
					$form->saveAsSettings();
				}
				
				/* Output */
				\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack('settings');
				\IPS\Output::i()->output = $form;		
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	/*-------------------------------------------------------------------------*/
	// Clear tthumb tasks
	/*-------------------------------------------------------------------------*/		
	protected function clearTThumbTasks()
	{
		try
		{
			try
			{
				\IPS\Db::i()->delete( 'core_queue', array( 'app=?', 'tthumb' ) );
				
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=forums&module=forums&controller=settings&do=tthumbSettings' ), 'tthumb_task_cleared' );	
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	protected function deleteTThumbData()
	{
		try
		{
			try
			{
				\IPS\Db::i()->delete( 'tthumb_images', null );
				
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=forums&module=forums&controller=settings&do=tthumbSettings' ) );	
				}
				catch ( \Error | \RuntimeException $e )
				{
					if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
					{
						\IPS\Log::log( $e, 'hook_exception' );
					}
	
					if ( method_exists( get_parent_class(), __FUNCTION__ ) )
					{
						return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
					}
					else
					{
						throw $e;
					}
				}
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}

				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
	}	

	/*-------------------------------------------------------------------------*/
	// Rebuild thumbnails
	/*-------------------------------------------------------------------------*/		
	public function rebuildTopicThumbnail()
	{
		try
		{
			try
			{
				$perGo = 20;
		
				$prompt = \IPS\Request::i()->prompt ? \IPS\Request::i()->prompt : 0;
		
				if ( $prompt == 1 ) // Delete
				{
					$runTask = true;
					
					foreach( \IPS\Db::i()->select( '*', 'core_queue', array( 'app=?', 'tthumb' ) ) as $row )
					{
						if ( $row['key'] == 'deleteTopicThumbnail' || $row['key'] == 'rebuildTopicThumbnail' )
						{
							$runTask = false;
							break;
						}
					}
		
					if ( $runTask )
					{
						\IPS\Task::queue( 'tthumb', 'deleteTopicThumbnail', array(), 4 );
						\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=forums&module=forums&controller=settings&do=tthumbSettings' ), 'tthumb_task_del_created' );			
					}
					else
					{
						\IPS\Output::i()->error( 'tthumb_error_running_task', '2BIMTTHUMB102/2', 404 );
					}
				}
				else
				{
					$runTask = true;
					
					foreach( \IPS\Db::i()->select( '*', 'core_queue', array( 'app=?', 'tthumb' ) ) as $row )
					{
						if ( $row['key'] == 'deleteTopicThumbnail' || $row['key'] == 'rebuildTopicThumbnail' )
						{
							$runTask = false;
							break;
						}
					}
					
					if ( $runTask )
					{
						\IPS\Task::queue( 'tthumb', 'rebuildTopicThumbnail', array(), 4 );
						\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=forums&module=forums&controller=settings&do=tthumbSettings' ), 'tthumb_task_rebuild_created' );		
					}
					else
					{
						\IPS\Output::i()->error( 'tthumb_error_running_task', '2BIMTTHUMB102/3', 404 );
					}
				}
				
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=forums&module=forums&controller=settings&do=tthumbSettings' ) );
				}
				catch ( \Error | \RuntimeException $e )
				{
					if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
					{
						\IPS\Log::log( $e, 'hook_exception' );
					}
	
					if ( method_exists( get_parent_class(), __FUNCTION__ ) )
					{
						return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
					}
					else
					{
						throw $e;
					}
				}
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}

				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
	}	
	
	/*-------------------------------------------------------------------------*/
	// From IPS 4.5, we no longer alter existing database tables, so we need to
	// run this step to copy records to new table.
	/*-------------------------------------------------------------------------*/	
	public function updateForIPS45()
	{
		try
		{
			try
			{
				$perGo = 100;
				$total = \IPS\Db::i()->select( 'COUNT(*)', 'forums_topics', "upload_thumbnail IS NOT NULL OR topic_thumbnail IS NOT NULL" )->first();
		
				\IPS\Output::i()->output = new \IPS\Helpers\MultipleRedirect( 
					\IPS\Http\Url::internal( 'app=forums&module=forums&controller=settings&do=updateForIPS45' ), 
					function( $doneSoFar ) use( $perGo, $total )
					{
						$select = \IPS\Db::i()->select( '*', 'forums_topics', "upload_thumbnail IS NOT NULL OR topic_thumbnail IS NOT NULL", 'tid desc', array( $doneSoFar, $perGo ) );
						
						if ( !$select->count() )
						{
							return NULL;
						}
									
						foreach ( $select as $row )
						{
							try
							{
								\IPS\Db::i()->select( '*', 'tthumb_images', array( 'img_topic_id=?', $row['tid'] ) )->first();
								
								\IPS\Db::i()->update( 'tthumb_images', array( 
									'img_image'		=> $row['upload_thumbnail'],
									'img_thumb' 	=> $row['topic_thumbnail']
								), array( 'img_topic_id=?', $row['tid'] ) );
							}
							catch ( \UnderflowException $e ) 
							{					
								\IPS\Db::i()->insert( 'tthumb_images', array(
									'img_topic_id'	=> $row['tid'],
									'img_image'		=> $row['upload_thumbnail'],
									'img_thumb'		=> $row['topic_thumbnail'],
								) );		
							}
						}
						
						$doneSoFar += $perGo;
						if ( $doneSoFar >= $total )
						{
							return NULL;
						}
						return array( $doneSoFar, \IPS\Member::loggedIn()->language()->addToStack('tthumb_updating_db'), 100 * $doneSoFar / $total );				
					}, 
					function()
					{
						\IPS\Db::i()->dropColumn( 'forums_topics', 'topic_thumbnail' );
						\IPS\Db::i()->dropColumn( 'forums_topics', 'upload_thumbnail' );	
						\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=forums&module=forums&controller=settings&do=tthumbSettings' ), 'completed' );
					} 
				);	
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}
